//+------------------------------------------------------------------+
//|                                              .mq4 |
//|                               Copyright  2011,   |
//|                                                cmillion@narod.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, http://cmillion.narod.ru"
#property link      "cmillion@narod.ru"
//--------------------------------------------------------------------
extern string  J2JMA1="";     
extern int Length1_1 = 5; //     
           Length2_1 = 5; //     
           Phase1_1  = 100; //   ,    -100 ... +100,     ; 
           Phase2_1  = 100; //   ,    -100 ... +100,     ; 
           Shift_1   = 0; // c     
           Input_Price_Customs_1 = 0;/*  ,      
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */

           timeframe_1 = 0;           //.      . 0    .
extern string  J2JMA2="";     
extern int Length1_2 = 5; //     
           Length2_2 = 5; //     
           Phase1_2  = 100; //   ,    -100 ... +100,     ; 
           Phase2_2  = 100; //   ,    -100 ... +100,     ; 
           Shift_2   = 0; // c     
           Input_Price_Customs_2 = 0;/*  ,      
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */

           timeframe_2 = 0;           //.      . 0    .
extern string  J2JMA3="";     
extern int Length1_3 = 5; //     
           Length2_3 = 5; //     
           Phase1_3  = 100; //   ,    -100 ... +100,     ; 
           Phase2_3  = 100; //   ,    -100 ... +100,     ; 
           Shift_3   = 0; // c     
           Input_Price_Customs_3 = 0;/*  ,      
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */

           timeframe_3 = 0;           //.      . 0    .
extern string  .="";     
extern int     stoploss             = 0,           //
               takeprofit           = 0,           //
               TrailingStop         = 0,           //,  0,   
               NoLoss               = 0,           //  ,  0,     
               MaxOrders            = 1;           // -    
extern double  LOT                  = 0.1;         // 
extern bool    CloseRevers          = true;        //    
//--------------------------------------------------------------------
int TimeBar,STOPLEVEL,Magic=1234567890;
//--------------------------------------------------------------------
int start()
{
   STOPLEVEL=MarketInfo(Symbol(),MODE_STOPLEVEL);
   if (TrailingStop>=STOPLEVEL) TrailingStop();
   if (NoLoss>=STOPLEVEL) NoLoss();
   if (TimeBar==Time[0]) return(0);

   double MA10 = iCustom(NULL,timeframe_1,"J2JMA",Length1,Length2,Phase1,Phase2,Shift,Input_Price_Customs,0,0); //  - ,         
   double MA11 = iCustom(NULL,timeframe_1,"J2JMA",Length1,Length2,Phase1,Phase2,Shift,Input_Price_Customs,0,1); //  - ,         
   double MA20 = iCustom(NULL,timeframe_2,"J2JMA",Length1,Length2,Phase1,Phase2,Shift,Input_Price_Customs,0,0); //  - ,         
   double MA21 = iCustom(NULL,timeframe_2,"J2JMA",Length1,Length2,Phase1,Phase2,Shift,Input_Price_Customs,0,1); //  - ,         
   double MA3  = iCustom(NULL,timeframe_3,"J2JMA",Length1,Length2,Phase1,Phase2,Shift,Input_Price_Customs,0,0); //  - ,         
      
   double SL,TP;
   if (MA10>MA20&&MA11<MA21&&MA20>MA3)
   {
      if (CloseRevers) CLOSEORDER(OP_SELL);
      if (MaxOrders>OrdersTotal())       
      {
         if (takeprofit!=0) TP  = NormalizeDouble(Ask + takeprofit*Point,Digits); else TP = 0;
         if (stoploss!=0)   SL  = NormalizeDouble(Bid - stoploss*Point,Digits); else SL = 0;
         if (OrderSend(Symbol(),OP_BUY, LOT,NormalizeDouble(Ask,Digits),2,SL,TP," ",Magic,3)!=-1) TimeBar=Time[0]; 
         else Print("OrderSend BUY Error ",GetLastError(),"  SL ",SL,"  TP ",TP);
      }
   }
   if (MA10<MA20&&MA11>MA21&&MA20<MA3)
   {
      if (CloseRevers) CLOSEORDER(OP_BUY);
      if (MaxOrders>OrdersTotal()) 
      {
         if (takeprofit!=0) TP = NormalizeDouble(Bid - takeprofit*Point,Digits); else TP = 0;
         if (stoploss!=0)   SL = NormalizeDouble(Ask + stoploss*Point,Digits); else SL = 0;
         if (OrderSend(Symbol(),OP_SELL,LOT,NormalizeDouble(Bid,Digits),2,SL,TP," ",Magic,3)!=-1) TimeBar=Time[0]; 
         else Print("OrderSend SELL Error ",GetLastError(),"  SL ",SL,"  TP ",TP);
      }
   }
return(0);
}
//--------------------------------------------------------------------
void CLOSEORDER(int ord)
{
   for (int i=0; i<OrdersTotal(); i++)
   {                                               
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
         {
            if (OrderType()==OP_BUY && ord==OP_BUY)
               OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),3,CLR_NONE);
            if (OrderType()==OP_SELL && ord==OP_SELL)
               OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),3,CLR_NONE);
         }
      }   
   }
}
//--------------------------------------------------------------------
void TrailingStop()
{
   int tip,Ticket;
   double StLo,OSL,OOP;
   for (int i=0; i<OrdersTotal(); i++) 
   {  if (OrderSelect(i, SELECT_BY_POS))
      {  tip = OrderType();
         if (tip<2 && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
         {
            OSL   = NormalizeDouble(OrderStopLoss(),Digits);
            OOP   = NormalizeDouble(OrderOpenPrice(),Digits);
            Ticket = OrderTicket();
            if (tip==OP_BUY)             
            {
               StLo = NormalizeDouble(Bid-TrailingStop*Point,Digits);
               if (StLo > OSL && StLo > OOP)
               {  if (!OrderModify(Ticket,OOP,StLo,OrderTakeProfit(),0,White))
                     Print("TrailingStop Error ",GetLastError()," buy SL ",OSL,"->",StLo);
               }
            }                                         
            if (tip==OP_SELL)        
            {
               StLo = NormalizeDouble(Ask+TrailingStop*Point,Digits);
               if (StLo > OOP || StLo==0) continue;
               if (StLo < OSL || OSL==0 )
               {  if (!OrderModify(Ticket,OOP,StLo,OrderTakeProfit(),0,White))
                     Print("TrailingStop Error ",GetLastError()," sell SL ",OSL,"->",StLo);
               }
            } 
         }
      }
   }
}
//--------------------------------------------------------------------
void NoLoss()
{
   int tip,Ticket;
   double StLo,OSL,OOP;
   for (int i=0; i<OrdersTotal(); i++) 
   {  if (OrderSelect(i, SELECT_BY_POS))
      {  tip = OrderType();
         if (tip<2 && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
         {
            OSL   = NormalizeDouble(OrderStopLoss(),Digits);
            OOP   = NormalizeDouble(OrderOpenPrice(),Digits);
            Ticket = OrderTicket();
            if (tip==OP_BUY)             
            {
               if (OSL>OOP) continue;
               StLo = NormalizeDouble(OOP+Point,Digits);
               if (NormalizeDouble((Bid-OOP)/Point,0)>=NoLoss)
               {  if (!OrderModify(Ticket,OOP,StLo,OrderTakeProfit(),0,White))
                     Print("NoLoss Error ",GetLastError()," buy SL ",OSL,"->",StLo);
               }
            }                                         
            if (tip==OP_SELL)        
            {
               if (OSL<OOP) continue;
               StLo = NormalizeDouble(OOP-Point,Digits);
               if (NormalizeDouble((OOP-Ask)/Point,0)>=NoLoss)
               {  if (!OrderModify(Ticket,OOP,StLo,OrderTakeProfit(),0,White))
                     Print("NoLoss Error ",GetLastError()," sell SL ",OSL,"->",StLo);
               }
            } 
         }
      }
   }
}
//--------------------------------------------------------------------

